#pragma once

#include "UIListCommonDefine.hpp"
#include "ChatItem.h"
#include "INTalk.h"
#include <list>

class CChatDlg;

namespace DuiLib
{
	class ChatRoomItem : private INTalkClientEvents
	{
	public:
		ChatRoomItem();
		ChatRoomItem(const NE_MYROOM_DATA& myRoomData);
		ChatRoomItem(CChatDlg*  pChat);
		void CopyChatItem(CChatDlg*  pChat);
		CString GetLastFileOrStickerMsg(CString strLastUserID);
		BOOL IsInChatItem(CString strKeyword);
		size_t GetOnlineUserCount();
		size_t GetTotalUserCount();
		void UpdataChatItem();

		BOOL RequestChatLeaveInRecentChatList(CString strSrvAddress, int nPort, int nRoomID, CString strMyID, CString strMyName, CString strMyTalkName);
		virtual void CALLBACK NtalkClient_OnCreateChatSession(INTalkClient* pNTClient, NTalkCreateChatType chatType, NTalkCreateSesionErrorCode eErrorCode);

	public:
		CDuiString			strUserID;
		CDuiString			strImage;
		CDuiString			strName;
		CDuiString			strLastMsg;
		CDuiString			strEMail;			// for single chat
		GTUserStatusType	eStatusType;		// for single chat
		CTime				tmLastTime;
		BOOL				bGroupChat;
		ECHAT_MSG_TYPE		eMsgGB;

		int					nRoomID;
		CChatDlg*			pChatDlg;
		INTalkClient*		pNtalk;
	};

	class CChatRoomList : public CListUI
	{
	public:
		enum {SCROLL_TIMERID = 10};

		CChatRoomList(CPaintManagerUI& paint_manager);
		~CChatRoomList();

		bool Add(CControlUI* pControl);
		bool AddAt(CControlUI* pControl, int iIndex);
		bool Remove(CControlUI* pControl);
		bool RemoveAt(int iIndex);
		void RemoveAll();
		void DoEvent(TEventUI& event);
		Node* GetRoot();
		Node* AddChattingRoomNode(const ChatRoomItem& item, Node* parent = NULL);
		Node* FindNodeByCompareData(int nCpr);
		Node* GetNodeByIndex(int index);
		bool RemoveNode(Node* node);
		void SetChildVisible(Node* node, bool visible); 
		void SetNodeEditable(Node* node, bool bEdit);
		bool CanExpand(Node* node) const;
		list<Node*> GetSelectedItems();
		list<Node*> GetAllItems();
		void SetSelectItemSize(int nWidth, int nHeight);
		void SetNormalItemSize(int nWidth, int nHeight);
		void SetSelectViewModal(CControlUI* pControl, bool bSelect);
		CString ParseChatTime(CTime tmChat);

	public:
		CPaintManagerUI& paint_manager_;
	private:
		Node*	root_node_;
		LONG	delay_deltaY_;
		DWORD	delay_number_;
		DWORD	delay_left_;
		CDuiRect	text_padding_;
		int level_text_start_pos_;
		//CDuiString level_expand_image_;
		//CDuiString level_collapse_image_;

		int m_nItemNormalWidth;
		int m_nItemNormalHeight;
		int m_nItemSelectedWidth;
		int m_nItemSelectedHeight;

		CDialogBuilder m_dlgBuilder;
	};

} // DuiLib
